import "antd/es/tooltip/style";
import _Tooltip from "antd/es/tooltip";
import "antd/es/tag/style";
import _Tag from "antd/es/tag";
import "antd/es/input/style";
import _Input from "antd/es/input";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React, { Component } from 'react';
import './index.less';

var InputTag = /*#__PURE__*/function (_Component) {
  _inherits(InputTag, _Component);

  var _super = _createSuper(InputTag);

  function InputTag(props) {
    var _this;

    _classCallCheck(this, InputTag);

    _this = _super.call(this, props);
    _this.state = {
      tags: props.value || [],
      inputValue: '',
      editIndex: -1
    };
    return _this;
  }

  _createClass(InputTag, [{
    key: "triggerChange",
    value: function triggerChange(e) {
      var _this$props$onChange = this.props.onChange,
          onChange = _this$props$onChange === void 0 ? function () {} : _this$props$onChange;
      onChange(e);
    }
  }, {
    key: "updateTag",
    value: function updateTag(index, tag) {
      var _this$state = this.state,
          tags = _this$state.tags,
          inputValue = _this$state.inputValue;
      var tagsNew = [].concat(_toConsumableArray(tags.slice(0, index)), [inputValue], _toConsumableArray(tags.slice(index + 1)));
      this.setState({
        tags: tagsNew,
        editIndex: -1,
        inputValue: ''
      });
      this.triggerChange(tagsNew);
    }
  }, {
    key: "addTag",
    value: function addTag() {
      var _this$state2 = this.state,
          tags = _this$state2.tags,
          inputValue = _this$state2.inputValue;

      if (inputValue && tags.indexOf(inputValue) === -1) {
        tags = [].concat(_toConsumableArray(tags), [inputValue]);
      }

      this.setState({
        tags: tags,
        editIndex: -1,
        inputValue: ''
      });
      this.triggerChange(tags);
    }
  }, {
    key: "removeTag",
    value: function removeTag(index) {
      var tagsOld = this.state.tags;
      var tags = [].concat(_toConsumableArray(tagsOld.slice(0, index)), _toConsumableArray(tagsOld.slice(index + 1)));
      this.setState({
        tags: tags
      });
      this.triggerChange(tags);
    }
  }, {
    key: "showInput",
    value: function showInput(editIndex, inputValue) {
      var _this2 = this;

      this.setState({
        editIndex: editIndex,
        inputValue: inputValue
      }, function () {
        return _this2.input.focus();
      });
    }
  }, {
    key: "renderTag",
    value: function renderTag(tag, index) {
      var _this3 = this;

      var _this$state3 = this.state,
          editIndex = _this$state3.editIndex,
          inputValue = _this$state3.inputValue;

      if (editIndex === index) {
        return /*#__PURE__*/React.createElement("div", {
          className: "edit-tag"
        }, /*#__PURE__*/React.createElement(_Input, {
          ref: function ref(e) {
            return _this3.input = e;
          },
          key: tag,
          size: "small",
          className: "tag-input",
          value: inputValue,
          onChange: function onChange(e) {
            return _this3.setState({
              inputValue: e.target.value
            });
          },
          onBlur: function onBlur(e) {
            return _this3.updateTag(index, inputValue);
          },
          onPressEnter: function onPressEnter(e) {
            return _this3.updateTag(index, inputValue);
          }
        }));
      }

      var isLongTag = tag.length > 20;
      var tagElem = /*#__PURE__*/React.createElement(_Tag, {
        className: "edit-tag",
        key: tag,
        closable: true,
        onClose: function onClose(e) {
          return _this3.removeTag(index);
        }
      }, /*#__PURE__*/React.createElement("span", {
        onDoubleClick: function onDoubleClick(e) {
          return _this3.showInput(index, tag);
        }
      }, isLongTag ? "".concat(tag.slice(0, 20), "...") : tag));
      return isLongTag ? /*#__PURE__*/React.createElement(_Tooltip, {
        title: tag,
        key: tag
      }, " ", tagElem, "  ") : tagElem;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props$addButtnT = this.props.addButtnText,
          addButtnText = _this$props$addButtnT === void 0 ? '添加标签' : _this$props$addButtnT;
      var _this$state4 = this.state,
          tags = _this$state4.tags,
          inputValue = _this$state4.inputValue,
          editIndex = _this$state4.editIndex;
      var tagCount = tags.length;
      return /*#__PURE__*/React.createElement("div", {
        className: "input-tag"
      }, tags.map(function (tag, index) {
        return _this4.renderTag(tag, index);
      }), tagCount == editIndex && /*#__PURE__*/React.createElement("div", {
        className: "edit-tag"
      }, /*#__PURE__*/React.createElement(_Input, {
        ref: function ref(e) {
          return _this4.input = e;
        },
        type: "text",
        size: "small",
        className: "tag-input",
        value: inputValue,
        onChange: function onChange(e) {
          return _this4.setState({
            inputValue: e.target.value
          });
        },
        onBlur: function onBlur(e) {
          return _this4.addTag();
        },
        onPressEnter: function onPressEnter(e) {
          return _this4.addTag();
        }
      })), tagCount != editIndex && /*#__PURE__*/React.createElement(_Tag, {
        className: "site-tag-plus",
        onClick: function onClick(e) {
          return _this4.showInput(tagCount);
        }
      }, addButtnText));
    }
  }]);

  return InputTag;
}(Component);

export { InputTag as default };