function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

export function getSearchItems(values) {
  var items = [];

  for (var key in values) {
    if (values.hasOwnProperty(key)) {
      var value = values[key];
      var field = key;
      var method = 0;
      var arr = key.split('|');

      if (arr.length == 2) {
        field = arr[0];
        method = arr[1];
      }

      if (method == '7') {
        value = value && value.join(',');
      }

      if (key != 'sort' && value != null && value !== '') {
        //8 时间范围
        if (method == '8') {
          if (value.length == 2) {
            items.push({
              filterId: field,
              field: field,
              method: 4,
              value: value[0]
            });
            items.push({
              filterId: field,
              field: field,
              method: 3,
              value: value[1]
            });
          }
        } else {
          if (value.format) {
            value = value.format('YYYY-MM-DD');
          }

          items.push({
            filterId: field,
            field: field,
            method: method,
            value: value
          });
        }
      }
    }
  }

  return items;
}
export function getSearchModel(values, sort) {
  var searchModel = {};
  var sortInfo = (sort || '').split('|');

  if (sortInfo.length == 2) {
    var sortName = sortInfo[0];
    searchModel.sortName = sortName.slice(0, 1).toUpperCase() + sortName.slice(1);
    searchModel.sortOrder = sortInfo[1];
  }

  searchModel.items = getSearchItems(values);
  return searchModel;
}
export function addSearchItem(searchModel) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      field = _ref.field,
      value = _ref.value,
      _ref$method = _ref.method,
      method = _ref$method === void 0 ? 0 : _ref$method;

  return _objectSpread(_objectSpread({}, searchModel), {}, {
    items: [].concat(_toConsumableArray(searchModel.items), [{
      field: field,
      value: value,
      method: method
    }])
  });
}