function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

export var defaultListData = {
  list: [],
  searchModel: {},
  pagination: {
    showSizeChanger: false,
    showQuickJumper: true,
    showTotal: function showTotal(total) {
      return "\u5171 ".concat(total, " \u6761\u6570\u636E");
    },
    current: 1,
    total: 0,
    pageSize: 10,
    hideOnSinglePage: true
  }
};
export var pListReducer = {
  querySuccess: function querySuccess(state, _ref) {
    var payload = _ref.payload;

    var list = payload.list,
        pagination = payload.pagination,
        rest = _objectWithoutProperties(payload, ["list", "pagination"]);

    return _objectSpread(_objectSpread({}, state), {}, {
      list: list,
      pagination: _objectSpread(_objectSpread({}, state.pagination), pagination)
    }, rest);
  },
  updateItem: function updateItem(state, _ref2) {
    var payload = _ref2.payload;
    var data = payload.data,
        id = payload.id;
    var filter = payload.filter ? payload.filter : function (m) {
      return m.id == id;
    };
    var index = state.list.findIndex(filter);

    if (index > -1) {
      var item = _objectSpread(_objectSpread({}, state.list[index]), data);

      return _objectSpread(_objectSpread({}, state), {}, {
        list: [].concat(_toConsumableArray(state.list.slice(0, index)), [item], _toConsumableArray(state.list.slice(index + 1)))
      });
    }

    return state;
  },
  deleteItem: function deleteItem(state, _ref3) {
    var payload = _ref3.payload;
    var id = payload.id;
    var index = state.list.findIndex(function (m) {
      return m.id == id;
    });

    if (index > -1) {
      return _objectSpread(_objectSpread({}, state), {}, {
        list: [].concat(_toConsumableArray(state.list.slice(0, index)), _toConsumableArray(state.list.slice(index + 1)))
      });
    }

    return state;
  },
  filterItem: function filterItem(state, _ref4) {
    var payload = _ref4.payload;
    var filter = payload.filter;
    var list = state.list.filter(filter);
    return _objectSpread(_objectSpread({}, state), {}, {
      list: _toConsumableArray(list)
    });
  },
  updateState: function updateState(state, _ref5) {
    var payload = _ref5.payload;
    return _objectSpread(_objectSpread({}, state), payload);
  }
}; //export default { defaultListData, pListReducer }