"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _utils = require("./utils");

var _QuickFilter = _interopRequireDefault(require("./QuickFilter"));

var _QuickSort = _interopRequireDefault(require("./QuickSort"));

var _FilterForm = _interopRequireDefault(require("./FilterForm"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var SearchToolBar = /*#__PURE__*/function (_Component) {
  _inherits(SearchToolBar, _Component);

  var _super = _createSuper(SearchToolBar);

  function SearchToolBar(parm) {
    var _this;

    _classCallCheck(this, SearchToolBar);

    _this = _super.call(this, parm);

    _this.getSearchModel = function (e) {
      return _this.getSearchModelValue();
    };

    return _this;
  }

  _createClass(SearchToolBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoLoad) {
        this.submit();
      }
    }
  }, {
    key: "submit",
    value: function submit() {
      this.props.onSubmit(this.getSearchModelValue());
    }
  }, {
    key: "getSearchModelValue",
    value: function getSearchModelValue() {
      var values = this.filterForm.form.current ? this.filterForm.form.current.getFieldsValue() : [];
      var filters = this.quickFilter.getValue();
      var sort = this.quickSort.getValue();
      var searchModel = (0, _utils.getSearchModel)(_objectSpread(_objectSpread({}, values), filters), sort);
      return searchModel;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          _this$props$quickFilt = _this$props.quickFilterItems,
          quickFilterItems = _this$props$quickFilt === void 0 ? [] : _this$props$quickFilt,
          _this$props$quickSort = _this$props.quickSortItems,
          quickSortItems = _this$props$quickSort === void 0 ? [] : _this$props$quickSort;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "search-toolbar-wrap"
      }, /*#__PURE__*/_react.default.createElement(_QuickFilter.default, {
        items: quickFilterItems,
        ref: function ref(_ref) {
          return _this2.quickFilter = _ref;
        },
        onChange: function onChange(e) {
          return _this2.submit();
        }
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "search-toolbar ".concat(quickSortItems.length > 0 ? 'search-toolbar-with-sort' : '')
      }, /*#__PURE__*/_react.default.createElement(_QuickSort.default, {
        ref: function ref(_ref2) {
          return _this2.quickSort = _ref2;
        },
        items: quickSortItems,
        onChange: function onChange(e) {
          return _this2.submit();
        }
      }), /*#__PURE__*/_react.default.createElement(_FilterForm.default, _extends({
        ref: function ref(e) {
          return _this2.filterForm = e;
        }
      }, this.props, {
        onSubmit: function onSubmit(e) {
          return _this2.submit();
        }
      }))));
    }
  }]);

  return SearchToolBar;
}(_react.Component);

exports.default = SearchToolBar;